-- MasterLootNWOP.lua
-- Author: KiLLerBoy_001

--Globals 
local GlobalItemLink = ""
local GlobalSlotID = ""
local Timer = 1
local Debug = false  
local History = {}
local HisCnt= 1
local Channel = "RAID"
local NWOPLoaded = false 
local comment = ""
local Empty = ""


local function Debugprint(str) 
	if Debug then 
		print("|cFFF49242DEBUG: |cFFE3DEDB"..str)
	end 
end

local function tog(bool)
	if bool == false then 
		return true 
	else 
		return false 
	end
end 

local function getBoolean(val)
	if val then
		return true
	else
		return false
	end
end

defaults = {
	enabled = true,
	Autopassstr = "|cFFD4AF37[NWOP]|cFFE3DEDB Auto Passed - [ItemLink] - |cFF50C878Icompatible",
	Needstr = "Need: [CurrentItemLink]",
	PassStr = "|cFFD4AF37[NWOP]|cFFE3DEDB Selected pass on: [ItemLink]",
	RelicStr = "Need: [Level] Current: [OldSpell] New: [NewSpell]",
}

local function LoadSettings()

	if NWOPLoaded == false then
		NWOPLoaded =true 
		print("|cFFD4AF37[NWOP]|cFFE3DEDB Loaded ")
		
	MasterlootNWOPVar = MasterlootNWOPVar or {}

	for key,value in pairs(defaults) do
		if MasterlootNWOPVar[key] == nil then
			MasterlootNWOPVar[key] = value
		end
	end

	options = MasterlootNWOPVar
	
	local config = CreateFrame("Frame")

	config.name = "Masterloot NWOP"

	config.title = config:CreateFontString("AIconfigTitleFont", "ARTWORK", "GameFontNormal")
	config.title:SetFont(GameFontNormal:GetFont(), 16, "OUTLINE")
	config.title:SetPoint("TOPLEFT", config, 10, -10)
	config.title:SetText(config.name)

	config.enablebox = CreateFrame("CheckButton", "AIenableButton", config, "InterfaceOptionsCheckButtonTemplate")
	config.enablebox:SetPoint("TOPLEFT", config, 10, -25)
	config.enablebox:SetChecked(options.enabled)
	config.enablebox:SetHitRectInsets(0, -200, 0, 0)
	config.enableboxtitle = config:CreateFontString("AIconfigEnableboxFont", "ARTWORK", "GameFontNormal")
	config.enableboxtitle:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.enableboxtitle:SetPoint("LEFT", config.enablebox, 30, 0)
	config.enableboxtitle:SetText("|cffffffff" .."Enable addon".. "|r")

	
	config.AutopassLab = config:CreateFontString("AIconfigchanneltitleFont", "ARTWORK", "GameFontNormal")
	config.AutopassLab:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.AutopassLab:SetPoint("TOPLEFT", config, 10, -65)
	config.AutopassLab:SetText("|cffffffff" .."Auto-pass text :".. "|r")

	config.autopassbox = CreateFrame("EditBox", "AIoutputbox", config, "InputBoxTemplate")
	config.autopassbox:SetPoint("TOPLEFT", config, 20, -80)
	config.autopassbox:SetSize(400, 25)
	config.autopassbox:SetAutoFocus(false)
	config.autopassbox:SetMultiLine(false)
	config.autopassbox:SetText(options.Autopassstr)
	config.autopassbox:SetCursorPosition(0)
	config.autopassbox:SetScript("OnEnterPressed", function(self) self:ClearFocus() end)

	
	config.NeedLab = config:CreateFontString("AIconfigchanneltitleFont", "ARTWORK", "GameFontNormal")
	config.NeedLab:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.NeedLab:SetPoint("TOPLEFT", config, 10, -128)
	config.NeedLab:SetText("|cffffffff" .."Gear need text :".. "|r")

	config.needbox = CreateFrame("EditBox", "AIoutputbox", config, "InputBoxTemplate")
	config.needbox:SetPoint("TOPLEFT", config, 20, -148)
	config.needbox:SetSize(400, 25)
	config.needbox:SetAutoFocus(false)
	config.needbox:SetMultiLine(false)
	config.needbox:SetText(options.Needstr)
	config.needbox:SetCursorPosition(0)
	config.needbox:SetScript("OnEnterPressed", function(self) self:ClearFocus() end)	config.NeedLab = config:CreateFontString("AIconfigchanneltitleFont", "ARTWORK", "GameFontNormal")

	
	config.NeedRelicLab = config:CreateFontString("AIconfigchanneltitleFont", "ARTWORK", "GameFontNormal")
	config.NeedRelicLab:SetFont(GameFontNormal:GetFont(), 12, "OUTLINE")
	config.NeedRelicLab:SetPoint("TOPLEFT", config, 10, -191)
	config.NeedRelicLab:SetText("|cffffffff" .."Relic need text :".. "|r")

	config.needRelicbox = CreateFrame("EditBox", "AIoutputbox", config, "InputBoxTemplate")
	config.needRelicbox:SetPoint("TOPLEFT", config, 20, -211)
	config.needRelicbox:SetSize(400, 25)
	config.needRelicbox:SetAutoFocus(false)
	config.needRelicbox:SetMultiLine(false)
	config.needRelicbox:SetText(options.RelicStr)
	config.needRelicbox:SetCursorPosition(0)
	config.needRelicbox:SetScript("OnEnterPressed", function(self) self:ClearFocus() end)	config.NeedLab = config:CreateFontString("AIconfigchanneltitleFont", "ARTWORK", "GameFontNormal")

	
	config.okay = function(self)
		options.Autopassstr = config.autopassbox:GetText()
		options.Needstr = config.needbox:GetText()
	    options.RelicStr = config.needRelicbox:GetText()
		MasterlootNWOPVar = options
	end

	config.cancel = function(self)
		config.autopassbox:SetText(options.Autopassstr)
		config.needbox:SetText(options.Needstr)
	end
	
	InterfaceOptions_AddCategory(config)
	end
end

local function GetSlotID(itemEquipLoc,itemType)
	if itemEquipLoc == 'INVTYPE_HEAD' then return 1
	elseif itemEquipLoc == 'INVTYPE_NECK' then return 2
	elseif itemEquipLoc == 'INVTYPE_SHOULDER' then return 3
	elseif itemEquipLoc == 'BODY' then return 4
	elseif itemEquipLoc == 'INVTYPE_CHEST' then return 5
	elseif itemEquipLoc == 'INVTYPE_ROBE' then return 5
	elseif itemEquipLoc == 'INVTYPE_WAIST' then return 6
	elseif itemEquipLoc == 'INVTYPE_LEGS' then return 7
	elseif itemEquipLoc == 'INVTYPE_FEET' then return 8
	elseif itemEquipLoc == 'INVTYPE_WRIST' then return 9
	elseif itemEquipLoc == 'INVTYPE_HAND' then return 10
	elseif itemEquipLoc == 'INVTYPE_FINGER' then return 11 -- and 12
	elseif itemEquipLoc == 'INVTYPE_TRINKET' then return 13 -- and 14
	elseif itemEquipLoc == 'INVTYPE_CLOAK' then return 15
	elseif itemEquipLoc == 'INVTYPE_WEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_SHIELD' then return 17
	elseif itemEquipLoc == 'INVTYPE_2HWEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONMAINHAND' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONOFFHAND' then return 17
	elseif itemEquipLoc == 'INVTYPE_HOLDABLE' then return 17
	elseif itemEquipLoc == 'INVTYPE_RANGED' then return 16
	elseif itemEquipLoc == 'INVTYPE_THROWN' then return 16
	elseif itemEquipLoc == 'INVTYPE_RANGEDRIGHT' then return 16
	elseif itemEquipLoc == 'INVTYPE_RELIC' then return 18 --needs something else 
	elseif itemType =='Gem' then return 18 --needs something else
	else return nil
	end
end

local function ItemLinkToID(Linky)
local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
    Suffix, Unique, LinkLvl, Name = string.find(Linky,
    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	return Id
end

local MainFrameDesign = {
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  
  edgeFile = "Interface\\FriendsFrame\\UI-Toast-Border",
  tile = true,
  tileSize = 16,
  edgeSize = 8,
  insets = {
    left = 4,
    right = 4,
    top = 4,
    bottom = 4
  }
}

local NWOPMain = CreateFrame("Frame", "NGOP", UIParent)
NWOPMain:SetSize(280, 130); -- 105
NWOPMain:SetPoint("BOTTOM", 0, 250)
NWOPMain:SetFrameStrata("TOOLTIP");
NWOPMain:EnableMouse(true)
NWOPMain:SetBackdrop(MainFrameDesign) 
NWOPMain:SetMovable(true)
NWOPMain:RegisterForDrag("LeftButton")
NWOPMain:SetScript("OnDragStart", function(self) NWOPMain:StartMoving() end)
NWOPMain:SetScript("OnDragStop", function(self) NWOPMain:StopMovingOrSizing() end)
NWOPMain:SetScript("OnEnter", function() Tooltip_OnEnter(GlobalItemLink) end)
NWOPMain:SetScript("OnLeave", function() Tooltip_OnLeave() end)
NWOPMain:Hide()

local NeedButton = CreateFrame("Button", "NeedButton", NWOPMain)
local NeedText = NeedButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")

local WantButton = CreateFrame("Button", "WantButton", NWOPMain)
local WantText = WantButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")

local PassButton = CreateFrame("Button", "PassButton", NWOPMain)
local PassText = PassButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")

local Selection1Button = CreateFrame("Button", "Selection1Button", NWOPMain)
local Selection1Text = Selection1Button:CreateFontString(nil, "OVERLAY", "GameFontGreen")

local Selection2Button = CreateFrame("Button", "Selection2Button", NWOPMain)	
local Selection2Text = Selection2Button:CreateFontString(nil, "OVERLAY", "GameFontGreen")

local Comment = CreateFrame("EditBox", "AIoutputbox", NWOPMain, "InputBoxTemplate")
local CommentText = PassButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")

local function GetItemLevelIncreaseforRelic(LinkorID)
	_, _, _, itemLevel, _, _, _, _, _, _, _ =GetItemInfo(LinkorID)
	Debugprint("Ilvl from Relic: "..itemLevel)
	local var=(((itemLevel/5)-(710/5))*1.5+1)
	var = math.floor(var) 
	Debugprint("Ilvl added to Artifact: "..var)
	return var 
end

local function isToken(Link)
	local Bool = false
	local ID = ItemLinkToID(Link)
	local Classes = ClassesByTokenID[ID]
	if Classes~=nil and Classes[5] == 99 then
		Bool = true  
	end
	return Bool
end

local function isTokenForMe(Link)
	local Bool = false
	local ID = ItemLinkToID(Link)
	local Classes = ClassesByTokenID[ID]
	local _, _, classIndex = UnitClass("player")
	for i = 1, 4 do
		if Classes~=nil and Classes[i] == classIndex then
			Bool = true  
		end
	end
	return Bool
end

local function FireOncePer(seconds)
	if Timer>GetTime() then --Not yet
		Debugprint("Not Waiting long enough")
		return false
	elseif Timer<GetTime() then --Now
		Debugprint("Now you can go")
		Timer = (GetTime()+seconds)
		Debugprint("Timer Set")
		return true
	end
end

local function AddToHistory(str)
	History = MasterlootNWOPVar.History
	HisCnt = #MasterlootNWOPVar.History
	
	HisCnt = HisCnt+1
	History[HisCnt] = str
	
	MasterlootNWOPVar.History = History
end



local function Want()
    comment = Comment:GetText()
	name, realm = UnitName("player")
	RandomRoll(1,100)
	SendChatMessage(comment, Channel)
	NWOPMain:Hide()
end

local function AutoPass()
	msg = options.Autopassstr:gsub("%[ItemLink]", GlobalItemLink)
	print(msg)
	AddToHistory(msg)
end

local function IsRelicCompatible(ItemID)
	local bool = false 
	local WeaponID = ItemLinkToID(GetInventoryItemLink("player",16))
	local NewRelicID = ItemLinkToID(ItemID)
	
	SetCVar("Sound_EnableAllSound",0)
	if ArtifactFrame and ArtifactFrame:IsVisible() then -- Open frame if required 
		var = true
	else 
		var = false 
		SocketInventoryItem(16)
	end
		
	local _, _, _, NewRelicLink = C_ArtifactUI.GetRelicInfoByItemID(NewRelicID);
	local NewPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(NewRelicLink)
	local NewSpellLink = C_ArtifactUI.GetPowerHyperlink(NewPowers)
		
	for i = 1, C_ArtifactUI.GetNumRelicSlots() do
		if C_ArtifactUI.CanApplyRelicItemIDToSlot(NewRelicID, i) then
			bool = true 
		end
	end
	
	if var==false then  -- Hide frame if required
		C_ArtifactUI.Clear();
		ArtifactFrame:Hide()
	end
	SetCVar("Sound_EnableAllSound",1)
	return bool
end 

local function NeedSelected(link)
	NWOPMain:Hide()
	msg = options.Needstr:gsub("%[CurrentItemLink]", link) 
	SendChatMessage(msg.." : "..comment, Channel)
	AddToHistory(msg)
	
	Selection1Button:Hide()
	Selection2Button:Hide()
	Selection1Text:Hide()
	Selection1Text:Hide()
	NWOPMain:Hide()
end 

local function NeedSelectedRelic(Curlink,NewSpell,OldSpell)
	local Currentlevel = GetItemLevelIncreaseforRelic(Curlink) 
	local NewLevel = GetItemLevelIncreaseforRelic(GlobalItemLink) 
	local level = NewLevel-Currentlevel 
	local PosNeg
	local msg = ""
	
	if level > 0 then 
		PosNeg = "+"
	else
		PosNeg = ""
	end
	
	msg1 = options.RelicStr:gsub("%[Level]", PosNeg..level):gsub("%[NewSpell]",NewSpell)--:gsub("%[OldSpell]",OldSpell)
	msg = msg1:gsub("%[OldSpell]",OldSpell)
	
	SendChatMessage(msg.." : "..comment, Channel)
	AddToHistory(msg)
	
	Selection1Button:Hide()
	Selection2Button:Hide()
	Selection1Text:Hide()
	Selection1Text:Hide()
	NWOPMain:Hide()
end 

local function DoSelection(typevar,Texture1,Texture2,Link1,Link2,OldSpell1,Oldspell2,NewSpell)
	
	NeedButton:Hide()
	NeedText:Hide()
	
	WantButton:Hide()
	WantText:Hide()
	
	PassButton:Hide()
	PassText:Hide()
	
	Comment:Hide()
	CommentText:Hide()
	
	Selection1Button:SetSize(50,50);
	Selection1Button:SetPoint("LEFT", 50, -10)
	Selection1Button:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
	Selection1Button:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
	Selection1Button:SetNormalTexture(Texture1)
	Selection1Button:SetFrameStrata("TOOLTIP");
	Selection1Button:EnableMouse(true)
	Selection1Button:SetScript("OnEnter", function() Tooltip_OnEnter(Link1) end)
	Selection1Button:SetScript("OnLeave", function() Tooltip_OnLeave() end)
	Selection1Button:Show()
	
	Selection1Text:SetPoint("CENTER", 0, -30)
	Selection1Text:Show()
	
	Selection2Button:SetSize(50,50);
	Selection2Button:SetPoint("LEFT", 170, -10)
	Selection2Button:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
	Selection2Button:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
	Selection2Button:SetNormalTexture(Texture2)
	Selection2Button:SetFrameStrata("TOOLTIP");
	Selection2Button:EnableMouse(true)
	Selection2Button:SetScript("OnEnter", function() Tooltip_OnEnter(Link2) end)
	Selection2Button:SetScript("OnLeave", function() Tooltip_OnLeave() end)
	Selection2Button:Show()
	
	Selection2Text:SetPoint("CENTER", 0, -30)
	Selection2Text:Show()
	
	if typevar == "gear" then 
		Selection1Button:RegisterForClicks("AnyUp");
		Selection1Button:SetScript("OnMouseUp", function(self, LeftButton) NeedSelected(Link1) end)
		Selection1Text:SetText(" ")
		
		Selection2Button:RegisterForClicks("AnyUp");
		Selection2Button:SetScript("OnMouseUp", function(self, LeftButton) NeedSelected(Link2) end)
		Selection2Text:SetText(" ")
	elseif typevar == "relic" then
		local Currentlevel1 = GetItemLevelIncreaseforRelic(Link1)
		local Currentlevel2 = GetItemLevelIncreaseforRelic(Link2) 
		local NewLevel = GetItemLevelIncreaseforRelic(GlobalItemLink) 
		local level1 = NewLevel-Currentlevel1
		local level2 = NewLevel-Currentlevel2 		
		local PosNeg
		if level1 > 0 then 
			PosNeg = "+"
		else
			PosNeg = ""
		end
		if level2 > 0 then 
			PosNeg = "+"
		else
			PosNeg = ""
		end
		
		Selection1Text:SetText(PosNeg..level1)
		
		Selection1Button:RegisterForClicks("AnyUp");
		Selection1Button:SetScript("OnMouseUp", function(self, LeftButton) NeedSelectedRelic(Link1,NewSpell,OldSpell1) end)

		Selection2Text:SetText(PosNeg..level2)
		Selection2Button:RegisterForClicks("AnyUp");
		Selection2Button:SetScript("OnMouseUp", function(self, LeftButton) NeedSelectedRelic(Link2,NewSpell,OldSpell2) end)
	end
	
end 

local function Need()
	-- GlobalSlotID and GlobalItemLink are set by selection in main event on CheckMessage function
	comment = Comment:GetText()
	if GlobalSlotID == 18 then  -- Relics fucking relics
		local WeaponID = ItemLinkToID(GetInventoryItemLink("player",16))
		local NewRelicID = ItemLinkToID(GlobalItemLink)
		SetCVar("Sound_EnableAllSound",0)
		
		if ArtifactFrame and ArtifactFrame:IsVisible() then -- Open frame if required 
			var = true
		else 
			var = false 
			SocketInventoryItem(16)
		end
		
		local CurRelicName, CurRelicIcon, CurRelicType, CurRelicLink
		local CurPowers
		local CurSpellLink
		
		local Count = 1
		local CurRelicLinks = {}
		local CurSpellLinks = {}
		local CurRelicIcons = {}
		local slots = {}
		
		local NewRelicName, NewRelicIcon, NewRelicType, NewRelicLink = C_ArtifactUI.GetRelicInfoByItemID(ItemLinkToID(GlobalItemLink));
		local NewPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(NewRelicLink)
		local NewSpellLink = C_ArtifactUI.GetPowerHyperlink(NewPowers)
		
		for i = 1, C_ArtifactUI.GetNumRelicSlots() do
			if C_ArtifactUI.CanApplyRelicItemIDToSlot(NewRelicID, i) then
				CurRelicName, CurRelicIcon, CurRelicType, CurRelicLink = C_ArtifactUI.GetEquippedArtifactRelicInfo(i)

				CurPowers = C_ArtifactUI.GetPowersAffectedByRelic(i)
				CurSpellLink = C_ArtifactUI.GetPowerHyperlink(CurPowers)
				
				CurRelicLinks[Count] = CurRelicLink
				CurSpellLinks[Count] = CurSpellLink
				CurRelicIcons[Count] = CurRelicIcon
				slots[Count] = i
				Debugprint("Found Applicabale Relic slot: "..i)
				Count = Count +1
			end
		end
		
		if var==false then  -- Hide frame if required
			C_ArtifactUI.Clear();
			ArtifactFrame:Hide()
			SetCVar("Sound_EnableAllSound",1)
		end
		local Countt = 0
		for j = 1, #CurSpellLinks do -- Need to add selection for now do 
			print("|cFFD4AF37[NWOP]|cFFE3DEDB Slot: "..slots[j].." Skill:"..CurSpellLinks[j].."  To: "..NewSpellLink)	
			Countt = Countt +1
		end
		
		if Countt > 1 then 
			DoSelection("relic",CurRelicIcons[1],CurRelicIcons[2],CurRelicLinks[1],CurRelicLinks[2],CurSpellLinks[1],CurSpellLinks[2],NewSpellLink)
		else 
			NeedSelectedRelic(CurRelicLink,NewSpellLink,CurSpellLink)
		end
		
	elseif GlobalSlotID == 11 then -- Need to add selection for now do 
		local Curitem = GetInventoryItemLink("player",11)
		local _, _, _, _, _, _, _, _, _, item1Texture, _ =GetItemInfo(Curitem)
		local Curitem2 = GetInventoryItemLink("player",12)
		local _, _, _, _, _, _, _, _, _, item2Texture, _ =GetItemInfo(Curitem2)
		DoSelection("gear",item1Texture,item2Texture,Curitem,Curitem2,nil,nil,nil)
	elseif GlobalSlotID == 13 then  -- Need to add selection for now do 
		Curitem = GetInventoryItemLink("player",13)
		local _, _, _, _, _, _, _, _, _, item1Texture, _ =GetItemInfo(Curitem)
		local Curitem2 = GetInventoryItemLink("player",14)
		local _, _, _, _, _, _, _, _, _, item2Texture, _ =GetItemInfo(Curitem2)
		DoSelection("gear",item1Texture,item2Texture,Curitem,Curitem2,nil,nil,nil)
	else
		local Curitem = GetInventoryItemLink("player",GlobalSlotID)
		local msg = options.Needstr:gsub("%[CurrentItemLink]", Curitem) 
		SendChatMessage(msg.." : "..comment, Channel)
		AddToHistory(msg)
		NWOPMain:Hide()
	end
end


local function Pass()
	msg = options.PassStr:gsub("%[ItemLink]", GlobalItemLink)
	NWOPMain:Hide()
	print(msg)
	AddToHistory(msg)
end


function Tooltip_OnEnter(link)
	if link ~= nil then
		GameTooltip_SetDefaultAnchor(GameTooltip, NWOPMain)
		GameTooltip:SetPoint("BOTTOM",NWOPMain, -300, 0)
		GameTooltip:SetHyperlink(link)
		GameTooltip:Show()
	end
end

function Tooltip_OnLeave()
  GameTooltip:Hide()
end


local TitleText = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontNormal")
TitleText:SetPoint("TOP", -28, -3)
TitleText:SetText("NWOP")
local TitleText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
TitleText2:SetPoint("TOP", 18, -3)
TitleText2:SetText("-ing for:")

local ItemText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
ItemText2:SetPoint("TOP", 0, -17)
ItemText2:SetText(GlobalItemLink)


NeedButton:SetSize(50,50);
NeedButton:SetPoint("LEFT", 20, -0)
NeedButton:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
NeedButton:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
NeedButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up")
NeedButton:SetFrameStrata("TOOLTIP");
NeedButton:EnableMouse(true)
NeedButton:RegisterForClicks("AnyUp");
NeedButton:SetScript("OnMouseUp", function(self, LeftButton) Need() end)
NeedButton:SetScript("OnEnter", function() Tooltip_OnEnter(GlobalItemLink) end)
NeedButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

NeedText:SetPoint("CENTER", 0, -30)
NeedText:SetText("NEED")

WantButton:SetSize(50,50);
WantButton:SetPoint("LEFT", 120, -0)
WantButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Down")
WantButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
WantButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
WantButton:SetFrameStrata("TOOLTIP");
WantButton:EnableMouse(true)
WantButton:RegisterForClicks("AnyUp");
WantButton:SetScript("OnMouseUp", function(self, LeftButton) Want() end)
WantButton:SetScript("OnEnter", function() Tooltip_OnEnter(GlobalItemLink) end)
WantButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

WantText:SetPoint("CENTER", 0, -30)
WantText:SetText("WANT")

PassButton:SetSize(50,50);
PassButton:SetPoint("LEFT", 220, -0)
PassButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Down")
PassButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
PassButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
PassButton:SetFrameStrata("TOOLTIP");
PassButton:EnableMouse(true)
PassButton:RegisterForClicks("AnyUp");
PassButton:RegisterForClicks("AnyUp");
PassButton:SetScript("OnMouseUp", function(self, LeftButton) Pass() end)

PassText:SetPoint("CENTER", 0, -30)
PassText:SetText("PASS")

Comment:SetPoint("LEFT", NWOPMain, 20, -50)
Comment:SetSize(240, 25)
Comment:SetFrameStrata("TOOLTIP");
Comment:EnableMouse(true)
Comment:SetAutoFocus(false)
Comment:SetMultiLine(false)
Comment:SetCursorPosition(0)

local function ShowGui()
	ItemText2:SetText(GlobalItemLink)
	
	NeedButton:Show()
	NeedText:Show()
	
	WantButton:Show()
	WantText:Show()
	
	PassButton:Show()
	PassText:Show()
	
	Comment:Show()
	CommentText:Show()
	Comment:SetText("")
	
	NWOPMain:Show()
end

function IsTypeCompatible(NewSubType,Link,Slot)
	local GearLink = GetInventoryItemLink("player",Slot)
	if GearLink ~= nill then
		local _, _, _, _, _, _, itemSubType, _, _, _, _ = GetItemInfo(GearLink)
		if itemSubType == NewSubType then 
			return true
		else
			return false
		end
	else
		print("|cFFf44242NWOP ERROR: |cFFE3DEDBCould not get player armor in slot:"..Slot)
		return false 
	end
	PriorLink = Link
end

local function PreCheckRunUI(iLink)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(iLink)
	local slotID = GetSlotID(itemEquipLoc,itemType)
					
	local Token = isToken(itemLink)
	if Token then
		Debugprint("Is Tier Token: "..itemLink)
		Comp = isTokenForMe(itemLink)
		local ID = ItemLinkToID(itemLink)
		slotID = SlotByTokenID[ID]
	elseif slotID~= 11 and slotID~=13 and slotID~=18 then 
		Debugprint("Gear with Type: "..itemLink)
		Comp = IsTypeCompatible(itemSubType,itemLink,slotID)
	elseif slotID==18 then
		Debugprint("Relic"..itemLink)					
		Comp = IsRelicCompatible(itemLink)
	else
		Debugprint("trinket/Ring"..itemLink)
		Comp = true 
	end
					
	GlobalSlotID = slotID
	GlobalItemLink = itemLink
					
	if slotID~=nil or Token then
		if Comp then
			Debugprint("Show UI")
			ShowGui()
		else
			Debugprint("Auto Passing")
			AutoPass()
		end
	end
end 		
		
		
local function CheckMessage(self, event, ...) --Check for incomming raid warnings containing itemlinks
	Debugprint("Event Fired")
	if FireOncePer(1) and options.enabled then
		if IsInRaid() then
			Method, _, MasterID = GetLootMethod()
			if true then --Method=="master" then)
				local msg, user = ...
				for iLink in msg:gmatch("|%x+|Hitem:.-|h.-|h|r") do
					Debugprint("Message with Itemlink")
					Channel="RAID"
					PreCheckRunUI(iLink)
				end
			end
		end
	end
end

--local function CheckMessage2(self, event, ...) --Check for incomming raid messaged containing itemlinks
--	Debugprint("Event Fired")
--	if FireOncePer(1) and options.enabled then
--		if IsInRaid() then
--			Method, _, MasterID = GetLootMethod()
--			if true then --Method=="master" then)
--				local msg, User = ...
--				local Name = GetUnitName("raid"..MasterID, false)
--				if User = Name then 
--					for iLink in msg:gmatch("|%x+|Hitem:.-|h.-|h|r") do
--						Debugprint("Message with Itemlink")
--						Channel="RAID"
--						PreCheckRunUI(iLink)
--					end
--				end
--			end
--		end
--	end
--end
	
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_WARNING", CheckMessage)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", CheckMessage2)

addonLoadedFrame = CreateFrame('Frame')
addonLoadedFrame:RegisterEvent("ADDON_LOADED")

local function Initialize(self, event, addonName, ...)
	if event == "ADDON_LOADED" then 
		LoadSettings()
	end
end

addonLoadedFrame:SetScript('OnEvent', Initialize)

local function BooltoStr(Bool)
	if Bool == true then 
		return "|cFF4ef442Enabled"
	else
		return "|cFFf44141Disabled"
	end
end

SLASH_NWOP1, SLASH_NWOP2 = '/nwop', '/masterloot';
local function handler(msg, editbox)
	local command, str = msg:match("^(%S*)%s*(.-)$");
	if command == 'debug' then
		Debug =tog(Debug)
		print("|cFFD4AF37[NWOP]|cFFE3DEDB Debug: "..BooltoStr(Debug));
	elseif command == "show" and str ~= "" then
		for iLink in str:gmatch("|%x+|Hitem:.-|h.-|h|r") do
			Channel="EMOTE"
			print("|cFFD4AF37[NWOP]|cFFE3DEDB Force Opened: "..iLink);
			PreCheckRunUI(iLink)
		end	
	elseif command == "printhistory" then
		History = MasterlootNWOPVar.History
		for i = 1, #History do 
			print(History[i])
		end
	elseif command == "store" then
		AddToHistory(str)
	elseif command == "load" then 
		LoadSettings()
		print("|cFFD4AF37[NWOP]|cFFE3DEDB Force loaded settings");
	else 
		print("|cFFD4AF37[NWOP]|cFFE3DEDB Command not recognized")
	end
	
end
SlashCmdList["NWOP"] = handler; -- Also a valid assignment strategy
